<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>nlinlsq</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="linregr.html">&lt;&lt; linregr</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="nlinregr.html">nlinregr &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">Regression tools (regtools)</a> &gt;&gt; <a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a> &gt; nlinlsq</span>

    <br /><br />
    <div class="info"></div>

  <div class="refnamediv"><h1 class="refname">nlinlsq</h1><p class="refpurpose">Non-linear [weighted] least square solver with statistical analysis of the solution.</p></div>



<div class="refsynopsisdiv"><h3 class="title">Calling Sequence</h3>
   <div class="synopsis"><pre><span class="default">[</span><span class="default">p</span><span class="default">,[</span><span class="default">stat</span><span class="default">]]=</span><span class="functionid">nlinlsq</span><span class="default">(</span><span class="default">funlist</span><span class="default">,</span><span class="default">dfun</span><span class="default">,</span><span class="default">x</span><span class="default">,</span><span class="default">y</span><span class="default">,[</span><span class="default">wt</span><span class="default">],</span><span class="default">p0</span><span class="default">,[</span><span class="default">plo</span><span class="default">],[</span><span class="default">pup</span><span class="default">],[</span><span class="default">info</span><span class="default">],[</span><span class="default">algo</span><span class="default">],[</span><span class="default">df</span><span class="default">])</span>
<span class="default">p</span><span class="default">=</span><span class="functionid">nlinlsq</span><span class="default">(</span><span class="default">funlist</span><span class="default">,[],</span><span class="default">x</span><span class="default">,</span><span class="default">y</span><span class="default">,[],</span><span class="default">p0</span><span class="default">) </span><span class="comment">// shortest call - with numerical derivatives</span>
<span class="functionid">nlinlsq</span><span class="default">(</span><span class="default">stat</span><span class="default">)  </span><span class="comment">// print report from a previously solved regression problem.</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">funlist:</span>
      <dd><p class="para">string - name of non-linear model (or list with additional parameters)</p></dd></dt>
   <dt><span class="term">dfun:</span>
      <dd><p class="para">optional function returning the derivative of the non-linear model wrt the regression parameters p. If dfun=&#0039;&#0039; numerical derivaties are used.</p></dd></dt>
   <dt><span class="term">x:</span>
      <dd><p class="para">matrix - independent variables (as column vectors)</p></dd></dt>
   <dt><span class="term">y:</span>
      <dd><p class="para">column vector - dependent variables</p></dd></dt>
   <dt><span class="term">wt:</span>
      <dd><p class="para">optional column vector with weights for each dependent variable y (typically wt=(1)./y).</p></dd></dt>
   <dt><span class="term">p0:</span>
      <dd><p class="para">column vector - inital estimates for regression parameters</p></dd></dt>
   <dt><span class="term">plo:</span>
      <dd><p class="para">optional column vector - lower bounds for regression parameters</p></dd></dt>
   <dt><span class="term">pup:</span>
      <dd><p class="para">optional column vector - upper bounds for regression parameters</p></dd></dt>
   <dt><span class="term">info:</span>
      <dd><p class="para">optional list - output options</p></dd></dt>
   <dt><span class="term">info(1):</span>
      <dd><p class="para">scalar - =0; (default) no output; =1 summary report after solution; &gt;1 output after every info(1)&#0039;th iteration.</p></dd></dt>
   <dt><span class="term">info(2):</span>
      <dd><p class="para">optional text matrix or space separated string with names for the regression parameters. If not present p(1), p(2),... are used as names for the regression parameters in p.</p></dd></dt>
   <dt><span class="term">algo:</span>
      <dd><p class="para">optional string - solution method (&#0039;qn&#0039; -(default) quasi-newton, &#0039;gc&#0039; - conjugate gradient, &#0039;nd&#0039; - non-differentiable model.)</p></dd></dt>
   <dt><span class="term">df:</span>
      <dd><p class="para">optional scalar - degrees of freedom for non linear regression problem</p></dd></dt>
   <dt><span class="term">p:</span>
      <dd><p class="para">vector - least square solution of regression parameters p</p></dd></dt>
   <dt><span class="term">stat:</span>
      <dd><p class="para">optional structure - statistical data from parmeter estimation problem.</p></dd></dt>
   <dt><span class="term">stat.ss :</span>
      <dd><p class="para">weighted residual sum of squares ( ss = (wt.*res)&#0039;*(wt.*res) )</p></dd></dt>
   <dt><span class="term">stat.df :</span>
      <dd><p class="para">degrees of freedom ( df = length(y) - length(p) )</p></dd></dt>
   <dt><span class="term">stat.res :</span>
      <dd><p class="para">vector with residuals ( res = y-funlist(p,x,...) )</p></dd></dt>
   <dt><span class="term">stat.p :</span>
      <dd><p class="para">vector with solution of the WLSQ problem ( min sum(res.^2) subject to plo le p le pup )</p></dd></dt>
   <dt><span class="term">stat.pint :</span>
      <dd><p class="para">confidence interval (alfa=5%) for reqression parameters ( pint = devp*cdft(&#0039;T&#0039;,df,1-alfa/2,alfa/2) )</p></dd></dt>
   <dt><span class="term">stat.covp :</span>
      <dd><p class="para">parameter covariance matrix ( covp = inv(df/ss*(J&#0039;*J)) where J is the Jacobi matrix of res wrt p at the solution)</p></dd></dt>
   <dt><span class="term">stat.corp :</span>
      <dd><p class="para">parameter correlation matrix ( corp = covp./sqrt(devp2*devp2&#0039;); where devp2=devp.^2; )</p></dd></dt>
   <dt><span class="term">stat.devp :</span>
      <dd><p class="para">standard error ( devp = sqrt(diag(covp)) ).</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">nlinlsq solves non linear weigthed least square problems
using the Scilab function optim as the non-linear optimization routine.</p>
   <p class="para">Minimize SS = SUM(i, (wt*(y(i) - f(p,x(i))))^2 ) with respect to plo le p le pup.</p>
   <p class="para">The gradient information for the optim algorithm is estimated numerically using the
numdiff function, unless dfun is defined - in which case df/dp = dfun(p,x,...) is used.
dfun(p,x,...) should return [df/dp(1) df/dp(2) ... df/dp(np)] as a column matrix.</p>
   <p class="para">Model parameters are automatically scaled using the values in p0 as scaling factors.
If max(p/p0)gt1000 or min(p/p0)le1e-3 it may be wise to re run
nlinlsq with the new solution as initial quess in order to provide better scaling of the model parameters.</p>
   <p class="para">Statistical analysis inspired by the nls function in R (www.r.org) is available through the output variable stat.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><a class="scilabcommand" href="scilab://deff">deff</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">yhat=nlinmod(p,x)</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabstring">&#0039;</span><span class="scilabstring">yhat=p(1)+p(2)*exp(p(3)*x);</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// define regression model to be fitted</span>
<a class="scilabcommand" href="scilab://deff">deff</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">dydp=dnlinmod(p,x)</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabstring">&#0039;</span><span class="scilabstring">dydp=[ones(x),exp(p(3)*x),p(2)*x.*exp(p(3)*x)];</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// define d(yhat)/dp</span>
<span class="scilabid">x</span><span class="scilaboperator">=</span><span class="scilaboperator">-</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabspecial">:</span><span class="scilabnumber">100</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilaboperator">/</span><span class="scilabnumber">10</span><span class="scilabdefault">;</span> <span class="scilabid">phat</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">2</span><span class="scilabdefault">;</span><span class="scilabnumber">10</span><span class="scilabdefault">;</span><span class="scilabnumber">0.5</span><span class="scilabopenclose">]</span><span class="scilabdefault">;</span>               <span class="scilabcomment">// generate some data points</span>
<span class="scilabid">y</span><span class="scilaboperator">=</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">(</span><span class="scilabid">phat</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabopenclose">)</span><span class="scilaboperator">+</span><a class="scilabcommand" href="scilab://grand">grand</a><span class="scilabopenclose">(</span><span class="scilabnumber">100</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">nor</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">0</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">/</span><span class="scilabnumber">2</span><span class="scilabdefault">;</span>    <span class="scilabcomment">// with with random noice added.</span>
<span class="scilabid">p0</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://ones">ones</a><span class="scilabopenclose">(</span><span class="scilabnumber">3</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// initial estimate for the regression parameters.</span>
<span class="scilabcomment">// Solve nonlinear regression problem with output every 4</span><span class="scilabcomment">&#0039;</span><span class="scilabcomment">th iteration and nameing of model parmameters.</span>
<span class="scilabopenclose">[</span><span class="scilabid">p</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">nlinlsq</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabid">dnlinmod</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabid">p0</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">4</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">A B C</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabcomment">// Solve weighted nonlinear regression problem with default names for the regression parameters</span>
<span class="scilabcomment">// and numerical derivatives.</span>
<span class="scilabopenclose">[</span><span class="scilabid">pwt</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">nlinlsq</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabopenclose">(</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">./</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabid">p0</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabnumber">10</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabcomment">// Show the difference between the two solutions...</span>
<a class="scilabmacro" href="scilab://scf">scf</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabmacro" href="scilab://plot">plot</a><span class="scilabopenclose">(</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">o</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabcommand" href="scilab://xtitle">xtitle</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Demo of nlinlsq()</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">x</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">y=A+B*exp(C*x)</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span>
<a class="scilabmacro" href="scilab://plot">plot</a><span class="scilabopenclose">(</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">(</span><span class="scilabid">p</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">b-</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabmacro" href="scilab://plot">plot</a><span class="scilabopenclose">(</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">(</span><span class="scilabid">pwt</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">r-</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<a class="scilabcommand" href="scilab://xgrid">xgrid</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabmacro" href="scilab://legend">legend</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Data</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">unweighted</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">weighted</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabcomment">// Solve weighted nonlinear regression problem without analytical derivaties.</span>
<span class="scilabopenclose">[</span><span class="scilabid">pwt</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">nlinlsq</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabid">nlinmod</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabid">x</span><span class="scilabdefault">,</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabopenclose">(</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">./</span><span class="scilabid">y</span><span class="scilabdefault">,</span><span class="scilabid">p0</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabnumber">10</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">clc</span><span class="scilabdefault">;</span>
<span class="scilabcomment">// Display the regression report from the previous solution.</span>
<span class="scilabid">nlinlsq</span><span class="scilabopenclose">(</span><span class="scilabid">stat</span><span class="scilabopenclose">)</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="nlinregr.html" class="link">nlinregr</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">T. Pettersen, top@tpett.com</li></ul></div>


    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="linregr.html">&lt;&lt; linregr</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="nlinregr.html">nlinregr &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
